local numbers={}
numbers.effect = love.graphics.newPixelEffect[[

// All Hail Spaghetti!
// iichan.hk/dev
// translated to Love by Ref 2013-5-24

const number PID2 = 3.14/2.0;

extern number	time;
extern vec2		screen;
extern number	cpx;
extern number	cpy;
extern number	size;

bool six( vec2 pos )
{
	vec2 ipos = 2.0 * pos - vec2( 1.0 );
	bool s1, s2;
	{
		vec2	rp	= ipos * vec2(1.0, 1.3) + vec2(0.0, 0.5);
		number	x	= dot(rp, rp);
		s1 			= (x > 0.28) && (x < 0.5);
	}
	{
		vec2	rp	= ipos * vec2(1.0, 1.1) - vec2(0.0, 0.4);
		number	x	= dot(rp, rp);
		s2		= (x > 0.28) && (x < 0.5) && (rp.y > 0.0);
	}
	bool s3		= (pos.x > 0.146) && (pos.x < 0.235) && (pos.y > 0.33) && (pos.y < 0.69);
	return s1 || s2 || s3;
}

number digit( vec2 pos, int d )
{
	if ((pos.x < 0.0) || (pos.y < 0.0) || (pos.x > 1.0) || (pos.y > 1.0)) return 0.0;

	bool	on		= false;
	vec2	ipos	= 2.0 * pos - vec2(1.0);
	if ( d == 0 )									// components of each digit
		{
		vec2	rp	= ipos * vec2(1.5, 1.0);
		number	x	= dot(rp, rp);
		on			= (x > 0.65) && (x < 1.0);
		}
	else if (d == 1)
		{
		number	t	= pos.y - pos.x;
		bool	s1	= (pos.x > 0.3) && (pos.x < 0.55) && (t > 0.4) && (t < 0.55);
		bool	s2	= (pos.x > 0.45) && (pos.x < 0.55);
		on			= s1 || s2;
		}
	else if (d == 2)
		{ bool s1, s2;
			{
			vec2	rp	= ipos - vec2( 0.001, 0.37 );	// magic number (0.001)
			number	x	= dot(rp, rp);
			s1			= (atan(rp.x, rp.y) > -PID2) && (x > 0.2) && (x < 0.35);
			}
			{
			vec2	rp	= ipos + vec2(0.0, 0.69);
			number	x	= dot(rp, rp);
			number	a	= atan(rp.x, rp.y);
			s2 			= (a < 0.0) && (a > -PID2) && (x > 0.2) && (x < 0.35);
			}
		bool s3			= (pos.x > 0.2) && (pos.x < 0.8) && (pos.y < 0.16) && (pos.y > 0.05);
		on				= s1 || s2 || s3;
		}
	else if (d == 3)
		{
		bool s1, s2;
			{
			vec2	rp	= vec2(1.0, 1.3) * ipos - vec2(0.0, 0.65);
			number	x	= dot(rp, rp);
			s1			= ((rp.x > 0.0) || (rp.y > 0.0)) && (x > 0.2) && (x < 0.4);
			}
			{
			vec2	rp	= vec2(1.0, 1.1) * ipos + vec2(0.0, 0.45);
			number	x	= dot(rp, rp);
			s2			= ((rp.x > 0.0) || (rp.y < 0.0)) && (x > 0.2) && (x < 0.4);
			}
		on				= s1 || s2;
		}
	else if (d == 4)
		{
		number x1 = 2.2 * pos.x - pos.y;
		bool s1 = (x1 > 0.05) && (x1 < 0.25) && (pos.x > 0.2);
		bool s2 = (pos.x > 0.2) && (pos.x < 0.7) && (pos.y > 0.2) && (pos.y < 0.35);
		bool s3 = (pos.x > 0.5) && (pos.x < 0.6);
		on = s1 || s2 || s3;
		}
	else if (d == 5)
		{
		vec2 rp = ipos * vec2(1.0, 1.3) + vec2(0.0, 0.5);
		number x = dot(rp, rp);
		bool s1 = (rp.x > -0.5) && (x > 0.28) && (x < 0.5);
		bool s2 = (pos.x > 0.25) && (pos.x < 0.3) && (pos.y > 0.5);
		bool s3 = (pos.x > 0.25) && (pos.x < 0.82) && (pos.y > 0.92);
		on = s1 || s2 || s3;
		}
	else if (d == 6) on = six(pos);
	else if (d == 7)
		{
		number x = 2.5 * pos.x - pos.y;
		bool s1 = (x > 0.7) && (x < 0.9);
		bool s2 = (pos.x > 0.25) && (pos.x < 0.7) && (pos.y > 0.9);
		on = s1 || s2;
		}
	else if (d == 8)
		{ bool s1, s2;
			{
			vec2 rp = vec2(1.4, 1.8) * ipos - vec2(0.0, 0.92);
			number x = dot(rp, rp);
			s1 = (x > 0.4) && (x < 0.65);
			}
		{
			vec2 rp = vec2(1.0, 1.2) * ipos + vec2(0.0, 0.5);
			number x = dot(rp, rp);
			s2 = (x > 0.3) && (x < 0.48);
			}
		on = s1 || s2;
		}
	else
		on = six(vec2(1.0) - pos);
		return on ? 34.0 : 0.0;
}

number point(vec2 pos) {return (dot(pos, pos) < 0.0005) ? 1.0 : 0.0;}

const vec3 color_st		= vec3(1.0, 0.0, 0.0);		// colors of each digit
const vec3 color_s		= color_st;
const vec3 color_mst	= vec3(0.0, 0.0, 0.2);
const vec3 color_ms		= color_mst;
const vec3 color_point	= vec3(0.0, 1.0, 0.0);		// color of colon

vec4 effect( vec4 color, Image tex, vec2 tc, vec2 pc )
{
	vec2 position = pc.xy / (size*screen.y);	// larger = smaller numbers

	vec2 rect_st	= (position - vec2(cpx+.00, cpy)) * vec2(4.0, 3.0);
	vec2 rect_s		= (position - vec2(cpx+.25, cpy)) * vec2(4.0, 3.0);
	vec2 rect_mst	= (position - vec2(cpx+.60, cpy)) * vec2(4.0, 3.0);
	vec2 rect_ms	= (position - vec2(cpx+.85, cpy)) * vec2(4.0, 3.0);

	int d_st		= int(mod(time * 0.1, 10.0));
	int d_s			= int(mod(time, 10.0));
	int d_mst		= int(mod(time * 10.0, 10.0));
	int d_ms		= int(mod(time * 100.0, 10.0));

	number k_st		= 1.0 - 0.5 * mod(time, 10.0) * 0.1;
	number k_s		= 1.0 - 0.5 * mod(time * 10.0, 10.0) * 0.1;

	number point_blink = smoothstep(0.0, 1.0, 2.0 * abs(mod(time, 1.0) - 0.5));

	vec3 clor =
		k_st * digit(rect_st, d_st) * color_st +
		k_s * digit(rect_s, d_s) * color_s +
		digit(rect_mst, d_mst) * color_mst +
		digit(rect_ms, d_ms) * color_ms +
		point_blink * point(position - vec2(cpx+.55, cpy+.25)) * color_point +
		(1.0 - point_blink) * point(position - vec2(cpx+.55, cpy+.10)) * color_point;

	vec4 pixel	= Texel(tex, tc);
		pixel.r = clor[0];
		pixel.g = clor[1];
		pixel.b = clor[2];
		pixel.a = 1.0;
	return pixel;
	}
]]
return numbers
